%
%


:- ['~/quail_local/aktbus/prolog/src/absl'].	%load AKT Bus module
:- ['../../prolog/util/print_xml'].
:- ['../../prolog/util/cif2xml'].

:- [url].		%load sender & receiver URL

go :-
	sender_url(Url),
	write('...creating AKT-Bus receiver at:'),
	write(Url),
	nl,
	absl:create_aktbus_receiver(Url,Receiver),
	write('...waiting for incoming message at:'),
	write(Url),
	nl,
	repeat,
	absl:receive_message(Receiver,Message),
	print_xml:print_xml(Message),
	nl,
	%
	% get content of KQML tell
	%
	absl:decompose_message(_,_,_,_,_,Aktmessage_content,_,Message),
	absl:get_env(Aktmessage_content,'akt-kqml:KqmlContent',_,Kqml_content),
	absl:get_env(Kqml_content,'akt-kqml:content',_,[Tell_content]),
	Params=[representation=classic,
		constraint_id=generate
		],
	Tell_content_with_xml_header=[xmldecl([version='1.0']),env('rdf:RDF',[],Tell_content)],
	cif2xml:result2xml(Params,Result,Tell_content_with_xml_header),
	write('***result'),
	nl,
	write(Result),
	nl,
	fail.


