%
% sample constraints
%
:- module(sample_constraint,[	constraint/1,
				detail/3
				]).

constraint(c1).
constraint(c2).
constraint(c3).
constraint(c4).

detail(c1,description,'if a processor board is long, the allocated slot must be long').
detail(c1,daplex,'constrain all a in allocate all b in arg1(a) such that length(b as processor) = "long" to have length(arg2(a)) = "long"').
detail(c1,cif,Cif) :-
	Cif=restrict_subquery(
			all(var(uevar1)),
			[generate(allocate,var(uevar1))],
			[restrict_subquery(
				all(var(uevar2)),
				[	generate(arg1,[allocate],[var(uevar1)],board,var(uevar2)),
					expression(var(evar3),[var(uevar2)],relative(processor,var(uevar2),var(evar3))),
					generate(length,[processor],[var(evar3)],string,var(evar4)),
					expression([],[var(evar4)],expr(=,var(evar4),long)
					)
				],
				[	generate(arg2,[allocate],[var(uevar1)],slot,var(evar5)),
					generate(length,[slot],[var(evar5)],string,var(evar6)),
					expression([],[var(evar6)],expr(=,var(evar6),long))
				]
			)
			]
		).

detail(c2,description,'if the power demand of a processor board is extra, then the slot must also suppport extra').

detail(c2,daplex,'constrain all a in allocate all b in arg1(a) such that extra_power_data(b as processor) = "extra" to have extra_power_data(arg2(a)) = "extra"').
detail(c2,cif,Cif) :-
	Cif=restrict_subquery(all(var(uevar3)),
			[generate(allocate,var(uevar3))],
			[restrict_subquery(all(var(uevar4)),
				[	generate(arg1,[allocate],[var(uevar3)],board,var(uevar4)),
					expression(var(evar9),[var(uevar4)],relative(processor,var(uevar4),var(evar9))),
					generate(extra_power_data,[processor],[var(evar9)],string,var(evar10)),
					expression([],[var(evar10)],expr(=,var(evar10),extra))
				],
				[	generate(arg2,[allocate],[var(uevar3)],slot,var(evar11)),
					generate(extra_power_data,[slot],[var(evar11)],string,var(evar12)),
					expression([],[var(evar12)],expr(=,var(evar12),extra))
				]
			)
			]
		).

detail(c3,description,'all slots must be long').
detail(c3,daplex,'').
detail(c3,cif,Cif) :-
	Cif=restrict_subquery(all(var(s)),
			[	generate(slot,var(s)),
				generate(length,[slot],[var(s)],string,var(sl))
			],
			[	expression([],[var(pl)],expr(=,var(sl),long))
			]
		).

detail(c4,description,'all slots must be short').
detail(c4,daplex,'').
detail(c4,cif,Cif) :-
	Cif=restrict_subquery(all(var(s)),
			[	generate(slot,var(s)),
				generate(length,[slot],[var(s)],string,var(sl))
			],
			[	expression([],[var(pl)],expr(=,var(sl),short))
			]
		).
