:- module(domain_knowledge,[	is_subclass/2,
				find_top_superclass/2
				]).

:- ['../pfdm_wrapper/ix_demo_database/pfdm_schema'].	%load pre-mapped P/FDM schema knowledge

subclass(Sub,Sup) :-
	pfdm_schema(declare(Sub,Sup)).

is_subclass(C1,C2) :-
	domain_knowledge:subclass(C1,C2),	%C1 is a subclass of C2 in the domain
	!.
 
is_subclass(C1,C2) :-
	domain_knowledge:subclass(C1,X),	%C1 is an indirect subclass of C2
	is_subclass(X,C2).



%
% from a list of classes, find the top level superclass
%
find_top_superclass(C,C) :-		%not a list, just an atom
	atom(C),
	!.

find_top_superclass([C],C) :-
	!.
 
find_top_superclass([C|Cs],C) :-
	find_top_superclass(Cs,Temp),
	is_subclass(Temp,C),
	!.

find_top_superclass([C|Cs],Temp) :-
	find_top_superclass(Cs,Temp),
	is_subclass(C,Temp),
	!.

