%
% test the KRAFT<->AKT gateway
%
:- ['../../prolog/util/ksl'].
:- ['../../prolog/messaging/messaging'].
:- ['../fusing_mediator/transform'].

%
%
%
init(k2a) :-
	ksl:read_agent_config,
	ksl:get_config(linda_host,Host),
	ksl:get_config(linda_port,Port),
	messaging:init_messaging([server_host:Host,server_port:Port]).

send(k2a) :-
	Sender=mulder,
	Receiver=foreign(url('quail.csd.abdn.ac.uk',11111,'/')),
	Perf=tell,
	get_constraint(Content),
	Param=[	language:cif,
		content:Content
		],
	messaging:compose_message(Sender,Receiver,Perf,Param,Message),
	messaging:send_message(Message).

get_constraint(Filled) :-
	C=restrict_subquery(all(var(p)),
			[	generate(pc,var(p)),
				generate(cpu,[pc],[var(p)],string,var(c))
			],
			[	expression([var(c)],[],expr(=,var(c),'pentium4'))
			]
		),
	transform:push_negation(C,Pushed),
	transform:rewrite(Pushed,Rewritten),
	transform:fillmissing(Rewritten,Filled).

