%
% background knowledge & inference rules added by KH
%

%
% as shown in JC-B's diagram
%

sub_class(board,device).
sub_class(agent,object).
sub_class(device,object).
sub_class(constraint,inca_constraint).
sub_class(dynamic_constraint,constraint).
sub_class(static_constraint,constraint).



%
% relates to INCA (added by KH)
%
sub_class(issue,inca_issue).
sub_class(object,inca_node).

%
% some class/1 missing
%
class(device).
class(inca_node).

%
% missing in JC-B's
%
property(slot,position,integer).
property(slot,length,long).
property(slot,extra_power_data,normal).

%
% corrected from JC-B's
%
sub_class(relationship,ix_entity).
att_domain(next_to,arg1,slot).
att_domain(next_to,arg2,slot).
att_domain(allocate,arg1,board).
att_domain(allocate,arg2,slot).

%
% JC-B's descriptions of relationships
%

%
% allocate/2
%
description(
	(allocate(X,Y) :-
		instance_of(X,board),
		instance_of(Y,slot)
		
	)
	).
description(
	(has(X,Y) :-
		instance_of(X,_),	%X is an instance of a class
		instance_of(Y,_)	%and Y too
		
	)
).



%
% to make P/FDM happy
%
class(ix_entity).
property(ix_entity,id,string).
key_of(ix_entity,id).

sub_class(inca_issue,ix_entity).
sub_class(inca_node,ix_entity).
sub_class(inca_constraint,ix_entity).

