:- ['~/quail_local/aktbus/prolog/src/absl'].
:- ['../../prolog/util/print_xml'].
:- use_module(library(charsio)).

go :-
	%
	Sender='http://quail.csd.abdn.ac.uk/me',
	Receiver='http://quail.csd.abdn.ac.uk:12340/',
	%
	% content of message
	%
	Content=env(issue,Attribs,[Issue_subtree]),
	Attribs=['send-id'=Sender_id],
	Sender_id=Sender,
	Issue_subtree=env(statement,[],[Statement_atom]),
	Statement=post_issue((_Sender,_Receiver),Issue),
	Issue=(_,_,_,_,_,Solutions),
	Solutions=[solution(_,_,Old_solution,_,_)],
	Constraints=Old_solution,
	%
	% constraint
	%
	Constraints=[ instance_of(X, processor),  
                      instance_of(Y, disk_controller),
                      instance_of(Z, io), 
                      allocate(X,  Slot1),
                      allocate(Y,  Slot2),
                      allocate(Z,  Slot3)
		],
	%
	% convert statement term into an atom
	%
	write_to_chars(Statement,Statement_string),
	name(Statement_atom,Statement_string),
	%
	% compose message
	%
	absl:compose_message(Sender,Receiver,Content,Message),
	%
	% send message
	%

%	pillow:xml2terms(S,Message),
%	absl:print_string(S).
	print_xml:print_xml(Message),
	nl,
	absl:send_message(Message).



/*
post_issue((Sender/Sender_role, Receiver/Receiver_role), 
      issue(Issue_Instance, 
            Issue, 
            Status, 
            Priority, 
            Begin_time/End_time, 
     
           [solution(
                Customer, 
                Requirements, 

                [ instance_of(X, processor),    % initial/basic solution 
                  instance_of(Y, disk_controller),
                  instance_of(Z, io), 
                  allocate(X,  Slot1),
                  allocate(Y,  Slot2),
                  allocate(Z,  Slot3),
                  total_cost(Cost) ], 

                New_solution,           % revised solution
                Add_list/Deleted_list
                    )])  
         ). 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% running example 1: for message content passing
% to the KRAFT system. 
%
% For the aberdeen side, Aberdeen does not need to alter total_cost
% predicate. Initially, three running examples have been created
% below. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% note that the capability description may be a subset
% of a particular type of board. 

post_issue((edinburgh/marketing, aberdeen/technology), 
 
      issue(issue1, 
            solve_technical_constraint,
            created,
            high, 
            1/End_time, 
     
            solution(john, 
                    [total_cost(M), 
                     less_than(M, 1000),
                    ], 

                    [ instance_of(X, processor),  
                      instance_of(Y, disk_controller),
                      instance_of(Z, io), 
                      allocate(X,  Slot1),
                      allocate(Y,  Slot2),
                      allocate(Z,  Slot3),
                      total_cost(Cost) ], 

                     New,          
                     Difference )
           )). 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% running example 2
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

post_issue((edinburgh/marketing, aberdeen/technology), 
 
      issue(issue2, 
            solve_technical_constraint,
            created,
            high, 
            2/End_time, 

            solution(mary, 
                     [total_cost(M), 
                      less_than(M, 1500)
                      special_req(B, capability, [fast_graphics])
                     ], 
                     [ instance_of(X, processor),  
                       instance_of(Y, disk_controller),
                       instance_of(Z, io), 
                       allocate(X,  Slot1),
                       allocate(Y,  Slot2),
                       allocate(Z,  Slot3),
                       total_cost(Cost) ], 
                      New,              
                      Difference )
          )). 

*/

