%
% testing agent to send translated IX constraints to KRAFT fusing mediator
%
:- ['../../prolog/util/ksl'].
:- ['../../prolog/messaging/messaging'].
:- ['../../prolog/util/cif_util'].
:- use_module(library(lists)).

go :-
	Sender=tester,
	Receiver=fm,
	Reply_with=test_123,
	ksl:read_agent_config,
	ksl:get_config(linda_host,Host),
	ksl:get_config(linda_port,Port),
	messaging:init_messaging([server_host:Host,server_port:Port]),		%init messaging layer
	findall(C,get_constraint(C),All_constraints),
	%
	% compose message
	%
	Cif=All_constraints,
%	cif_util:find_var_types(All_constraints,Vars_with_types),
%	findall(V,member(V:_,Vars_with_types),Output_vars),
%	findall(T,member(_:T,Vars_with_types),Output_types),

	Output_vars=[var(bx),var(sx)],
	Output_types=[board,slot],

	Empty=[	generate(allocate,_),
		generate(arg1,[allocate],_,_,_),
		generate(arg2,[allocate],_,_,_)
		],
        Pattern=[       Output_vars:Output_types,
                        generate(pc_config,[set_of(cif),set_of(cif)],[Cif,Empty],Output_types,Output_vars)
                ],
	Perf=ask_all,
	messaging:set_argument([	sender:Sender,
					receiver:Receiver,
					reply_with:Reply_with,
					content:Pattern,
					ontology:shared,
					language:xcif
				],Params),
	messaging:compose_message(Sender,Receiver,Perf,Params,Message),
	write(Message),
	nl,
	send_message(Message).

/*
get_constraint(C) :-
	C=restrict_subquery(all([var(ax),var(bx),var(px),var(sx)]),
		[
			generate(allocate, var(ax)),
			generate(board, var(bx)),
			generate(processor, var(px)),
			generate(slot, var(sx)),
			generate(arg1, [allocate], [var(ax)], board, var(bx)),
			generate(arg2, [allocate], [var(ax)], slot, var(sx)),
			relative(board, var(px), var(bx))
		],
		[icode_true]
		).
*/

/*
get_constraint(C) :-
	C=restrict_subquery(some([var(ax),var(bx),var(px),var(sx)]),
		[
			generate(allocate, var(ax)),
			generate(board, var(bx)),
			generate(processor, var(px)),
			generate(slot, var(sx)),
			generate(arg1, [allocate], [var(ax)], board, var(bx)),
			generate(arg2, [allocate], [var(ax)], slot, var(sx)),
			relative(board, var(px), var(bx))
		],
		[icode_true]
		).
*/

/*
get_constraint(C) :-
	C=restrict_subquery(some([var(12), var(11), var(10), var(9), var(8), var(7), var(6), var(5), var(4), var(3), var(2), var(1)]),
		[	generate(processor, var(1)),
			generate(disk_controller, var(2)),
			generate(io, var(3)),
			generate(allocate, var(4)),
			generate(arg1, [allocate], [var(4)], board, var(5)),
			relative(board, var(1), var(5)),
			generate(arg2, [allocate], [var(4)], slot, var(6)),
			generate(board, var(5)),
			generate(allocate, var(7)),
			generate(arg1, [allocate], [var(7)], board, var(8)),
			relative(board, var(2), var(8)),
			generate(arg2, [allocate], [var(7)], slot, var(9)),
			generate(board, var(8)),
			generate(allocate, var(10)),
			generate(arg1, [allocate], [var(10)], board, var(11)),
			relative(board, var(3), var(11)),
			generate(arg2, [allocate], [var(10)], slot, var(12)),
			generate(board, var(11)),
			generate(slot, var(6)),
			generate(slot, var(9)),
			generate(slot, var(12))
		],
		[icode_true]
		).
*/



get_constraint(C) :-
C=restrict_subquery(all([var(a),var(s),var(b),var(p),var(sl),var(pl)]),
	[	generate(allocate,var(a)),
		generate(processor,var(p)),
		generate(board,var(b)),
		relative(board,var(p),var(b)),
		generate(string,var(sl)),
		generate(string,var(pl)),
		generate(arg1,[allocate],[var(a)],board,var(b)),
		generate(arg2,[allocate],[var(a)],slot,var(s)),
		generate(length,[slot],[var(s)],string,var(sl)),
		generate(length,[processor],[var(p)],string,var(pl)),
		expression([],[],expr(=,var(pl),long))
	],
	[	expression([],[],expr(=,var(sl),long))
	]
	).


/*
get_constraint(C) :-
C=restrict_subquery(all([var(a2),var(s2),var(b2),var(p2),var(sp2),var(pp2)]),
	[	generate(allocate,var(a2)),
		generate(processor,var(p2)),
		generate(board,var(b2)),
		relative(board,var(p2),var(b2)),
		generate(string,var(sp2)),
		generate(string,var(pp2)),
		generate(arg1,[allocate],[var(a2)],board,var(b2)),
		generate(arg2,[allocate],[var(a2)],slot,var(s2)),
		generate(extra_power_data,[slot],[var(s2)],string,var(sp2)),
		generate(extra_power_data,[processor],[var(p2)],string,var(pp2)),
		expression([],[],expr(=,var(pp2),extra))
	],
	[	expression([],[],expr(=,var(sp2),extra))
	]
	).
*/

/*
get_constraint(C) :-
C=restrict_subquery(
        all([var(12),var(10),var(13),var(11),var(8),var(14),var(9)]),
        [
        generate(var(14),next_to),
        generate(var(10),optionI),
        generate(var(11),processor),
        generate(arg2,[allocate],[var(12)],slot,var(8)),
        generate(arg1,[allocate],[var(12)],board,var(10)),
        generate(var(12),allocate),
        generate(var(10),board),
        generate(var(8),slot),
        generate(arg2,[allocate],[var(13)],slot,var(9)),
        generate(arg1,[allocate],[var(13)],board,var(11)),
        generate(var(13),allocate),
        generate(var(11),board),
        generate(var(9),slot)
        ],
        [
        generate(arg2,[next_to],[var(14)],slot,var(9)),
        generate(arg1,[next_to],[var(14)],slot,var(8))
        ]
).

get_constraint(C) :-
C=restrict_subquery(
        all([var(19),var(17),var(20),var(18),var(15),var(21),var(16)]),
        [
        generate(var(21),next_to),
        generate(var(17),optionIII),
        generate(var(18),io),
        generate(arg2,[allocate],[var(19)],slot,var(15)),
        generate(arg1,[allocate],[var(19)],board,var(17)),
        generate(var(19),allocate),
        generate(var(17),board),
        generate(var(15),slot),
        generate(arg2,[allocate],[var(20)],slot,var(16)),
        generate(arg1,[allocate],[var(20)],board,var(18)),
        generate(var(20),allocate),
        generate(var(18),board),
        generate(var(16),slot)
        ],
        [
        generate(arg2,[next_to],[var(21)],slot,var(16)),
        generate(arg1,[next_to],[var(21)],slot,var(15))
        ]
).

get_constraint(C) :-
C=restrict_subquery(
        all([var(26),var(24),var(27),var(25),var(22),var(28),var(23)]),
        [
        generate(var(28),next_to),
        generate(var(24),optionIV),
        generate(var(25),disk_controller),
        generate(arg2,[allocate],[var(26)],slot,var(22)),
        generate(arg1,[allocate],[var(26)],board,var(24)),
        generate(var(26),allocate),
        generate(var(24),board),
        generate(var(22),slot),
        generate(arg2,[allocate],[var(27)],slot,var(23)),
        generate(arg1,[allocate],[var(27)],board,var(25)),
        generate(var(27),allocate),
        generate(var(25),board),
        generate(var(23),slot)
        ],
        [
        generate(arg2,[next_to],[var(28)],slot,var(23)),
        generate(arg1,[next_to],[var(28)],slot,var(22))
        ]
).
*/

