%
% this is a "make-up" panel that sends out an issue encoded in RDF
% as an AKT Message
%

:- ['~/quail_local/aktbus/prolog/src/absl'].	%load AKT Bus module
:- ['../../prolog/rdf2triple/rdf2triple'].	%load the rdf2triple module
:- ['../../prolog/util/print_xml'].

receiver_url('http://quail.csd.abdn.ac.uk:11111/').

go :-
	receiver_url(Url),
	go(Url).

go(Receiver) :-
	rdf2triple:clean_triple,			%clean up all triples in module rdf2triple
	add_all_triples,				%assert triples into module rdf2triple
	rdf2triple:triple2rdf(abbreviated,id(ip1),Rdf),	%map triples to RDF tree
	Rdf=env('rdf:RDF',_,Content),
	%
	write('*** sending issue:'),
	nl,
	Sender='http://quail.csd.abdn.ac.uk/~khui/akt/makeup_panel',
	Extra_namespace=['xmlns:ix_issue'='http://www.csd.abdn.ac.uk/~khui/akt/ix/issue-rdfs.xml'],
	absl:compose_message(Sender,Receiver,Content,Extra_namespace,Message),
	print_xml:print_xml(Message),
	nl,
	absl:send_message(Message).

add_all_triples :-
	namespace(X,Y),
	assertz(rdf2triple:namespace(X,Y)),
	fail.

add_all_triples :-
	triple(X,Y,Z),
	assertz(rdf2triple:triple(X,Y,Z)),
	fail.

add_all_triples.


%
% the issue defined as triples
%
namespace(rdf, 'http://www.w3.org/1999/02/22-rdf-syntax-ns#').
namespace(rdfs, 'http://www.w3.org/2000/01/rdf-schema#').
%namespace(cif, 'http://www.csd.abdn.ac.uk/~khui/akt/cif/cif-compact-rdfs.xml#')
namespace(ix_issue,'http://www.csd.abdn.ac.uk/~khui/akt/ix/issue-rdfs.xml#').

triple(id(ip1),rdf:type,ix_issue:issue_packet).

triple(id(ip1),ix_issue:issue_packet_issue_name,'solve_technical_constraint').
triple(id(ip1),ix_issue:issue_packet_receiver,'aberdeen').
triple(id(ip1),ix_issue:issue_packet_receiver_role,'technical').
triple(id(ip1),ix_issue:issue_packet_sender,'edinburgh').
triple(id(ip1),ix_issue:issue_packet_sender_role,'marketing').
triple(id(ip1),ix_issue:issue_packet_instance,anonymous(i)).

triple(anonymous(i),rdf:type,ix_issue:issue).
triple(anonymous(i),ix_issue:issue_status,created).
triple(anonymous(i),ix_issue:issue_priority,high).
triple(anonymous(i),ix_issue:issue_commmunicator,anonymous(c)).
triple(anonymous(i),ix_issue:issue_begin_time,anonymous(bt)).
triple(anonymous(i),ix_issue:issue_end_time,anonymous(et)).
triple(anonymous(i),ix_issue:issue_content,anonymous(sol)).

triple(anonymous(bt),rdf:type,ix_issue:time).
triple(anonymous(bt),ix_issue:time_year,'2002').
triple(anonymous(bt),ix_issue:time_month,'10').
triple(anonymous(bt),ix_issue:time_day,'21').
triple(anonymous(bt),ix_issue:time_hour,'18').
triple(anonymous(bt),ix_issue:time_minute,'44').
triple(anonymous(bt),ix_issue:time_second,'0').

triple(anonymous(et),rdf:type,ix_issue:time).
triple(anonymous(et),ix_issue:time_year,'2002').
triple(anonymous(bt),ix_issue:time_month,'10').
triple(anonymous(et),ix_issue:time_day,'21').
triple(anonymous(et),ix_issue:time_hour,'18').
triple(anonymous(et),ix_issue:time_minute,'45').
triple(anonymous(et),ix_issue:time_second,'30').

triple(anonymous(c),rdf:type,ix_issue:communicator).
triple(anonymous(c),ix_issue:communicator_requestor,edinburgh).
triple(anonymous(c),ix_issue:communicator_requestor_type,marketing).
triple(anonymous(c),ix_issue:communicator_provider,aberdeen).
triple(anonymous(c),ix_issue:communicator_provider_type,technical).

triple(anonymous(sol),rdf:type,ix_issue:solution).
triple(anonymous(sol),ix_issue:solution_customer,john).
triple(anonymous(sol),ix_issue:solution_requirement,'constraint(a,b)').
%triple(anonymous(sol),ix_issue:solution_old_solution,).
%triple(anonymous(sol),ix_issue:solution_new_solution,).
%triple(anonymous(sol),ix_issue:solution_difference,).

