pc_constraints(X) :-
	X=
[
/*
restrict_subquery(
	all(var(m)),
	[	generate(pc,var(p)),
		generate(memory,[pc],[var(p)],integer,var(m))
	],
	[
	restrict_subquery(
		all(var(s)),
		[generate(os,var(o)),
		generate(size,[os],[var(o)],integer,var(s))
		],
		[
		expression([],[],expr(>,var(s),var(m)))
		]
	)
	]
)
*/
restrict_subquery(
	all(var(so)),
	[generate(pc,var(p)),
	generate(has_os,[pc],[var(p)],os,var(o)),
	generate(size,[os],[var(o)],integer,var(so))
	],
	[restrict_subquery(
		some(var(sd)),
		[generate(has_disk,[pc],[var(p)],hard_disk,var(d)),
		generate(size,[hard_disk],[var(d)],integer,var(sd))
		],
		[expression([],[],expr(<,var(so),var(sd)))
		]
	)
	]
),
/*
restrict_subquery(
	all(var(uevar1)),
	[
	generate(pc,var(uevar1))
	],
	[	generate(cpu,[pc],[var(uevar1)],string,var(evar3)),
		expression([],[var(evar3)],expr(=,var(evar3),pentium))
	]
),
*/
restrict_subquery(
	all(var(uevar1)),
	[
	generate(pc,var(uevar1))
	],
	[	generate(has_os,[pc],[var(uevar1)],os,var(evar4)),
		generate(name,[os],[var(evar4)],string,var(evar5)),
		expression([],[var(evar5)],expr(<>,var(evar5),win95)),
		expression([],[var(evar5)],expr(<>,var(evar5),dos))
	]
),
restrict_subquery(
	all(var(uevar2)),
	[
	generate(pc,var(uevar2)),
	generate(has_os,[pc],[var(uevar2)],os,var(evar6)),
	generate(name,[os],[var(evar6)],string,var(evar7)),
	expression([],[var(evar7)],expr(=,var(evar7),winNT))
	],
	[
	generate(memory,[pc],[var(uevar2)],integer,var(evar8)),
	expression([],[var(evar8)],expr(>=,var(evar8),64))
	]
)
].

%
% sender's name
%
sender(user_agent).

%
% send constraints to fuser
%
ask_one_pc_config :-
	sender(Sender),
	Receiver=fm,
	Ontology=shared,
	Language=cif,
	Perf=ask_one,
	messaging:generate_id('ua_',Reply_with),
	pc_constraints(To_fuse),
	Empty_slots=[	generate(has_os,_,_,_,_)],
	Content=[	[var(p),var(o)]:[pc,os],
			generate(pc_config,[set_of(cif),set_of(cif)],[To_fuse,Empty_slots],[pc,os],[var(p),var(o)])
		],
	Ham=[	sender:Sender,
		receiver:Receiver,
		language:Language,
		ontology:Ontology,
		reply_with:Reply_with,
		content:Content
		],
	set_argument(Ham,Params),
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message).

%
% ask all PC configs
%
ask_all_pc_config :-
	sender(Sender),
	Receiver=fm,
	Ontology=shared,
	Language=cif,
	Perf=ask_all,
	messaging:generate_id('ua_',Reply_with),
	pc_constraints(To_fuse),
	Empty_slots=[	generate(has_os,_,_,_,_)],
	Content=[	[var(p),var(o)]:[pc,os],
			generate(pc_config,[set_of(cif),set_of(cif)],[To_fuse,Empty_slots],[pc,os],[var(p),var(o)])
		],
	Ham=[	sender:Sender,
		receiver:Receiver,
		language:Language,
		ontology:Ontology,
		reply_with:Reply_with,
		content:Content
		],
	set_argument(Ham,Params),
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message).

ask_all_cisco_constraints :-
	Sender=krl(aberdeen,kit),
	Receiver=krl(cardiff,cisco_db),
	messaging:generate_id('ua_',Reply_with),
	Ontology=shared,
	Language=cif,
	Perf=ask_all,
	Content=[	[var(ci)]:[string],
			[generate(constraintmeta,var(cm)),
			generate(constraint_icode,[constraintmeta],[var(cm)],string,var(ci))
			]
		],
	Params=[	sender:Sender,
			receiver:Receiver,
			reply_with:Reply_with,
			ontology:Ontology,
			language:Language,
			content:Content
		],
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message).






ask_all_3com_constraints :-
	Sender=krl(aberdeen,kit),
	Receiver=krl(liverpool,threecom_wrapper),
	messaging:generate_id(Num),
	name(Num,Num_string),
	append("ha_",Num_string,String),
	name(Reply_with,String),
	In_reply_to=q11,
	Ontology=shared,
	Language=cif,
	Perf=ask_all,
	Content=[	[var(ci)]:[string],
			[generate(constraintmeta,var(cm)),
			generate(constraint_icode,[constraintmeta],[var(cm)],string,var(ci))
			]
		],
	Params=[	sender:Sender,
			receiver:Receiver,
			reply_with:Reply_with,
			in_reply_to:In_reply_to,
			ontology:Ontology,
			language:Language,
			content:Content
		],
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message).
%
% recommend_one
%
recommend_all :-
	Sender=krl(aberdeen,kit),
	Receiver=krl(cardiff,facilitator),
	messaging:generate_id(Num),
	name(Num,Num_string),
	append("ha_",Num_string,String),
	name(Reply_with,String),
	Ontology=ccql,
	Language=ccql,
	Perf=recommend_all,
	Content=ccql(	ask_all,
			[	sender:krl(aberdeen,kit),
				language:cif,
				ontology:shared,
				content:[	[var(r)]:[router_port],
						router_port
					]
			]
		),
	Params=[	sender:Sender,
			receiver:Receiver,
			reply_with:Reply_with,
			ontology:Ontology,
			language:Language,
			content:Content
		],
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message).

recommend_one :-
	Sender=krl(aberdeen,kit),
	Receiver=krl(cardiff,facilitator),
	messaging:generate_id(Num),
	name(Num,Num_string),
	append("ha_",Num_string,String),
	name(Reply_with,String),
	Ontology=ccql,
	Language=ccql,
	Perf=recommend_one,
	Content=ccql(	ask_all,
			[	sender:krl(aberdeen,kit),
				language:cif,
				ontology:shared,
				content:[	[var(r)]:[router],
						generate(compatible_cpe,set_of(cif),[],router,var(r))
					]
			]
		),
	Params=[	sender:Sender,
			receiver:Receiver,
			reply_with:Reply_with,
			ontology:Ontology,
			language:Language,
			content:Content
		],
	format(">>> krl(aberdeen,kit) requesting recommend_one from krl(cardiff,facilitator) for compatible_cpe~n",[]),
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message).

ask_one_cpe :-
	Sender=krl(aberdeen,kit),
	Receiver=krl(aberdeen,godzilla),
	Ontology=shared,
	Language=cif,
	Perf=ask_one,
	messaging:generate_id(Num),
	name(Num,Num_string),
	append("ha_",Num_string,String),
	name(Reply_with,String),
	Content=[	[var(r)]:[router],
			generate(usable_cpe,set_of(cif),[],router,var(r))
		],
	set_argument([	sender:Sender,
			receiver:Receiver,
			ontology:Ontology,
			language:Language,
			content:Content,
			reply_with:Reply_with
			],
			Params),
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message).


ask_all_cpe :-
	Sender=krl(aberdeen,kit),
	Receiver=krl(aberdeen,godzilla),
	Ontology=shared,
	Language=cif,
	Perf=ask_all,
	messaging:generate_id(Num),
	name(Num,Num_string),
	append("ha_",Num_string,String),
	name(Reply_with,String),
	Content=[	[var(r)]:[router],
			generate(usable_cpe,set_of(cif),[],router,var(r))
		],
	set_argument([	sender:Sender,
			receiver:Receiver,
			ontology:Ontology,
			language:Language,
			content:Content,
			reply_with:Reply_with
			],
			Params),
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message).

what :-
Ham=[
     sender : krl(aberdeen,monster),
     receiver : krl(cardiff,facilitator),
     language : cif,
     ontology : advertisement,
     reply_with : rw_4,
     content : [
               :([],[]),

imperative([],[],
	'.'(create(advertisement,var(uevar4),
	'.'(scalar('krl(aberdeen,monster)',[]),
	'.'(scalar(rw_4,[]),[]))),
	'.'(let_multi(performativeList,'.'(var(uevar4),[]),ask_if,[]),
	'.'(let_multi(performativeList,'.'(var(uevar4),[]),ask_all,[]),
	'.'(let_multi(performativeList,'.'(var(uevar4),[]),ask_one,[]),
%	'.'(let_single(pattern,'.'(var(uevar4),[]),'usable_cpe(Constraints,OutputVar)',[]),[])))))
	'.'(let_single(pattern,'.'(var(uevar4),[]),'generate(usable_cpe,set_of(cif),Constraints,router,OutputVar)',[]),[])))))
	)

     ]
],
	Sender=krl(aberdeen,monster),
	Receiver=krl(cardiff,facilitator),
	Perf=advertise,
	set_argument(Ham,Params),
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message).



%
% send a list of constraints to the fuser
%
ask_one_fuse :-
	Sender=krl(aberdeen,kit),
	Receiver=krl(aberdeen,godzilla),
	Ontology=shared,
	Language=cif,
	Perf=ask_one,
	Reply_with=haliluya,
	To_fuse=[
		restrict_subquery(all(var(a)),
			[generate(router,var(a))],
			[constraint_on_router(var(a))]
		),
		restrict_subquery(all(var(b)),
			[generate(router,var(b)),
			filter_on_router(var(b))],
			[more_on_router(var(b))]
		),
		restrict_subquery(all(var(c)),
			[generate(router,var(c))],
			[even_more_on_router(var(c))]
		)
		],
	Content=[[var(r)]:[router],generate(compatible_cpe,set_of(cif),To_fuse,router,var(r))],
	Ham=[	sender:Sender,
		receiver:Receiver,
		language:Language,
		ontology:Ontology,
		reply_with:Reply_with,
		content:Content
		],
	set_argument(Ham,Params),
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message).

