%


:- ['../../prolog/util/ksl'].				%load KSL service layer
:- ['../../prolog/messaging/messaging'].		%load messaging layer

go :-
	ksl:read_agent_config,				%read agent config, from command line or HTTP or whatever
	ksl:get_config(linda_host,Host),		%get linda host+port
	ksl:get_config(linda_port,Port),
	init_messaging([server_host:Host,server_port:Port,id:random]).	%initialise messaging layer



ping(Somebody) :-
	Sender=user_agent,
	Receiver=Somebody,
	messaging:generate_id('ping_',Reply_with),
	Language=cif,
	Ontology=shared,
	Perf=ping,
	Ham=[	sender:Sender,
		receiver:Receiver,
		reply_with:Reply_with,
		ontology:Ontology,
		language:Language,
		content:[]
		],
	set_argument(Ham,Params),
	compose_message(Sender,Receiver,Perf,Params,Message),
	send_message(Message),
	poll(Sender).

poll(Me) :-
	receive_message_noblock(Me,Message),
	(	(	print_pc_result(Message),
			!
		);
		(	write(Message),
			nl
		)
	).

poll :-
	poll(user_agent).		%the default name


print_pc_result(Message) :-
	messaging:decompose_message(_,_,tell,Params,Message),	%check for TELL & get args
	messaging:get_argument(Params,content:Result),		%get content
	print_solve(Result).

print_solve([_:_,Tuples]) :-
	print_solve(Tuples).

print_solve([]).
print_solve([S|Ss]) :-
	S=solve(R),
	!,
	write(R),
	nl,
	print_solve(Ss).
print_solve([S|Ss]) :-
	write(S),
	nl,
	print_solve(Ss).


:-	format("*** consult the query files (e.g. q1.pl)",[]),
	format("*** and invoke queries",[]).

