%
% open pcdb and convert constraints into XCIF
%
:- use_module('../../prolog/util/i2cif').
:- use_module('../../prolog/util/print_cif').

dump :-
	cdescs(_,_,_,_,I,_),
	i2cif(I,C),
	format("pc_constraint(X) :- X=",[]),
	print_cif(C),
	write(.),
	nl,
	fail.

dump.

dump_header :-
	format(":- module(pc_constraints,[all_pc_constraints/1,pc_constraint/1]).~n~n",[]),
	listing(all_pc_constraints),
	nl.

all_pc_constraints(All) :-
	findall(X,pc_constraint(X),All).

:-	format("*** Loading PC database...~n",[]),
	open_module(pcdb_shared,read).
:-	format("*** Dumping constraints as XCIF...~n",[]),
	tell('pc_constraints.pl'),
	dump_header,
	dump,
	told.

:-	open_module(pcdb,read),
	dump,
	close_modules.
