%
% configuration file of the prolog2triple module
%

:- dynamic(known/3).

%
% is context loadable?
%
known(rdf,load,no).
known(rdfs,load,no).
known(cif_classic,load,yes).
known(cif_compact,load,yes).
known(query_result,load,yes).

%
% known URL
%
known(rdf,url,'http://www.w3.org/1999/02/22-rdf-syntax-ns').
known(rdfs,url,'http://www.w3.org/2000/01/rdf-schema').
known(cif_compact,url,'http://www.csd.abdn.ac.uk/~khui/akt/cif/cif-compact-rdfs.xml').
known(cif_classic,url,'http://www.csd.abdn.ac.uk/~khui/akt/cif/cif-classic-rdfs.xml').
known(query_result,url,'http://www.csd.abdn.ac.uk/~khui/akt/cif/cif-query-rdfs.xml').

%
% name of these in the final RDF document
% (when mapping from Prolog -> RDF)
%
known(rdf,name_in_rdf,rdf).
known(rdfs,name_in_rdf,rdfs).
known(cif_classic,name_in_rdf,cif).
known(cif_compact,name_in_rdf,cif).
known(query_result,name_in_rdf,daplex_query).

%
% known compiled RDFS file in triples
%
known(cif_compact,triple_file,'cif-compact-rdfs.triple').
known(cif_compact,triple_file,'/home/khui/kraft/prolog/rdf2triple/cif-compact-rdfs.triple').
known(cif_classic,triple_file,'cif-classic-rdfs.triple').
known(cif_classic,triple_file,'/home/khui/kraft/prolog/rdf2triple/cif-classic-rdfs.triple').
known(query_result,triple_file,'cif-query-rdfs.triple').
known(query_result,triple_file,'/home/khui/kraft/prolog/rdf2triple/cif-query-rdfs.triple').

%
% known class-property mapping files
%
known(cif_compact,class_property,'cif_compact_class_property.pl').
known(cif_classic,class_property,'cif_classic_class_property.pl').
known(query_result,class_property,'cif_query_class_property.pl').

