%
% testing cif2triple
%
% converting a CIF (in Prolog) into triples
%

:- [c2t].	%load the cif2triple module
:- [rdf2triple].
:- ['~/kraft/prolog/util/print_xml'].
:- ['../util/print_cif'].

go(Rep,Value) :-
Cif=restrict_subquery(
        all(var(uevar1)),
        [
        generate(pc,var(uevar1))
        ],
        restrict_subquery(
                all(var(evar3)),
                [
                generate(cpu,[pc],[var(uevar1)],string,var(evar3))
                ],
                restrict_subquery(
                        all(var(evar4)),
                        [
                        generate(has_os,[pc],[var(uevar1)],os,var(evar4))
                        ],
                        restrict_subquery(
                                all(var(evar5)),
                                [
                                generate(name,[os],[var(evar4)],string,var(evar5))
                                ],
                                [
                                expression([],[var(evar3)],expr(=,var(evar3),pentium2)),
                                expression([],[var(evar5)],expr(<>,var(evar5),win95))
                                ]
                        )
                )
        )
),
	Params=[representation=Rep,
		constraint_id=generate,
		domain_rdfs='http://www.csd.abdn.ac.uk/~khui/pcconfig'
		],
	%
	% map this CIF into a constraint
	%
	c2t:c2t(Cif,constraint,Params,Value,Triples),
	%
	% map triples back to Prolog term
	%
	Doc=this_doc,
	add_triple(Doc,Triples),
	c2t:t2c(Doc,Value,Cif_back),
	write('==='),nl,
	print_cif:print_cif(Cif_back),
	nl.

%	dump_list(Triples),
%	write('---RDF document---'),
%	nl,
%	add_triple(Triples),
%	rdf2triple:triple2rdf(abbreviated,Value,Rdf),
%	print_xml:print_xml(Rdf).

dump_list([]).
dump_list([X|Xs]) :-
	write(X),
	nl,
	dump_list(Xs).

add_triple(_,[]).
add_triple(Doc,[T|Ts]) :-
	assertz(triple:rdf_content(Doc,T)),
	add_triple(Doc,Ts).

