%
% read an URL and dump it as triples
%

:- ['../pillow/pillow'].
:- ['../util/print_xml'].
:- [rdf2triple].
:- use_module(library(lists)).

go :-
%	Url='http://www.csd.abdn.ac.uk/~khui/akt/cif/cif-query-rdfs-xml',
%	Url='http://www.csd.abdn.ac.uk/~khui/test.rdf',
%	Url='http://www.csd.abdn.ac.uk/~khui/akt/cif/cif-compact-rdfs.xml',
	Url='http://www.csd.abdn.ac.uk/~khui/akt/cif/examples/constraint/1-compact.xml',
	get_tree(Url,Xml_tree),				%get URL as an XML tree
	write(Xml_tree),
	nl,
	get_rdf_tree(Xml_tree,Rdf_tree),		%extract the RDF subtree from the XML tree
	rdf2triple:rdf2triple(Url,Rdf_tree),		%convert a Pillow XML tree into triples
	listing(triple:rdf_content).			%list RDF as triples
%	listing(rdf2triple:namespace),
%	listing(rdf2triple:triple),
%	rdf2triple:triple2rdf(classic,T).

%
% read an URL as an Pillow XML tree
%
get_tree(Url,Xml_tree) :-
	pillow:url_info(Url,Url_as_term),				%convert URL into a term
        pillow:fetch_url(Url_as_term,[],Response),			%fetch URL
        member(status(success,_,_),Response),				%check for success
        member(content(Content_string),Response),
        pillow:xml2terms(Content_string,Xml_tree).			%parse into XML tree

%
% extract an RDF subtree from an Pillow XML tree
% by looking for the 'rdf:RDF' tag
%
get_rdf_tree(Xml_tree,Rdf_tree) :-
	Rdf_tree=elem('rdf:RDF',_),
	member(Rdf_tree,Xml_tree).

get_rdf_tree(Xml_tree,Rdf_tree) :-
	Rdf_tree=env('rdf:RDF',_,_),
	member(Rdf_tree,Xml_tree).

