%
% testing cif2triple
%
% convert a CIF (in Prolog) into triples
%

:- [prolog2triple].
%:- [rdf2triple].
:- ['~/kraft/prolog/util/print_xml'].
:- ['../util/print_cif'].

go(Value) :-

%
% the constraint in CIF (Prolog form)
%
Cif=restrict_subquery(
        all(var(uevar1)),
        [
        generate(pc,var(uevar1))
        ],
        restrict_subquery(
                all(var(evar3)),
                [
                generate(cpu,[pc],[var(uevar1)],string,var(evar3))
                ],
                restrict_subquery(
                        all(var(evar4)),
                        [
                        generate(has_os,[pc],[var(uevar1)],os,var(evar4))
                        ],
                        restrict_subquery(
                                all(var(evar5)),
                                [
                                generate(name,[os],[var(evar4)],string,var(evar5))
                                ],
                                [
                                expression([],[var(evar3)],expr(=,var(evar3),pentium2)),
                                expression([],[var(evar5)],expr(<>,var(evar5),win95))
                                ]
                        )
                )
        )
),

	%
	% parameters to use when mapping the CIF to triples
	%
	Params=[constraint_id=generate,
		domain_rdfs='http://www.csd.abdn.ac.uk/~khui/pcconfig'
		],
	%
	% map this CIF into a constraint
	%
%	prolog2triple:prolog2triple(Cif,cif_classic,constraint,Params,_,_),
%	write('1st'),nl,

	%
	% map CIF to triples
	%
	prolog2triple:prolog2triple(Cif,cif_classic,constraint,Params,Value,Triples),
%	write('2nd'),nl,
%	prolog2triple:prolog2triple(Cif,cif_classic,constraint,Params,_,_),
%	write('3rd'),nl,
	%
	% map triples back to Prolog term
	%
	Doc=this_doc,
	add_triple(Doc,Triples),		%assert all triples into module "triple" as rdf_content/2
	listing(triple:rdf_content),		%dump triples to screen
	write('======================triple2prolog===================='),
	nl,
	prolog2triple:triple2prolog(Doc,Value,Cif_back),	%map triples back to CIF
	write('==='),nl,
	print_cif:print_cif(Cif_back),
	nl.

%	dump_list(Triples),
%	write('---RDF document---'),
%	nl,
%	add_triple(Triples),
%	rdf2triple:triple2rdf(abbreviated,Value,Rdf),
%	print_xml:print_xml(Rdf).

%
% dump a list to screen
%
dump_list([]).
dump_list([X|Xs]) :-
	write(X),
	nl,
	dump_list(Xs).

%
% assert a list of triples into the "triple" module as rdf_content/2
%
add_triple(_,[]).
add_triple(Doc,[T|Ts]) :-
	assertz(triple:rdf_content(Doc,T)),
	add_triple(Doc,Ts).

