:- module(my_union,[	my_union/2,
			my_union/3
		]).

:- [prolog_detect].
:- prolog_detect:prolog(Prolog),
	(	(	Prolog=sicstus,
			use_module(library(lists))
		);
		(	Prolog=pfdm,
			use_module(library(lists))
		);
		true
	).

%
% my_union/2
%
% take a union of multiple sets
%
% my_union(+Sets,-Union)
%
% Sets  =       the list of sets
% Union =       the union of all sets
%

my_union([],[]).

my_union([S|Ss],U) :-
	my_union(Ss,Temp),
	my_union(S,Temp,U).


%----------------------------------------------
% a union/3 that works with list/single element
%----------------------------------------------

my_union(X,Y,Z) :-
	X=[_|_],
	Y=[_|_],
%	is_list(X),
%	is_list(Y),
	!,
	my_union2(X,Y,Z).
my_union(X,Y,Z) :-
%	is_list(Y),
	Y=[_|_],
	!,
	my_union2([X],Y,Z).
my_union(X,Y,Z) :-
%	is_list(X),
	X=[_|_],
	!,
	my_union2(X,[Y],Z).
my_union(X,Y,Z) :-
	my_union2([X],[Y],Z).

my_union2([],L,L).
my_union2([H|T],L,Result) :-
	my_union2(T,L,Temp),                    %proceed w/ tail 1st
	(       (	member(H,Temp),         %if H is already in temp result
			!,
			Result=Temp             %then ommit H
		);
		(	Result=[H|Temp]         %otherwise keep H
		)
	).

